#define RING_BUFFER_MAX 90

extern bank3 volatile unsigned char ring_buffer[];

extern bank1 volatile unsigned char ring_buffer_index_in;
extern bank1 volatile unsigned char ring_buffer_index_out;

void ring_buffer_setup(void);
void ring_buffer_put(unsigned char data);
unsigned char ring_buffer_get(void);

unsigned char ring_buffer_empty_timeout(void);

//use to wait for ever until data is available in ring buffer, ie: while(ring_buffer_empty);
#define ring_buffer_empty		(ring_buffer_index_in==ring_buffer_index_out)

//*****
//the following definitions are applicable to anything

//this is used to reset a ring buffer for the first time
#define ring_reset(x,MIN_RING)	x=MIN_RING;

//whenever any index to a ring buffer is incremented, it should be
//	checked for wrap around
#define ring_inc(x,MIN_RING,MAX_RING)	x++;if (x>=MAX_RING) x=MIN_RING

//this checks for wrap around example C: if (ring_wrap(ringbuffer,MIN_RING)) //do things ...
#define ring_wrap(x,MIN_RING) (x==MIN_RING)


